// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('app', ['ionic', 'appControllers', 'appServices', 'appDirectives', 'ngAnimate'])

.run(function($rootScope, $ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
  $rootScope.navigated = false;
  $rootScope.$on('$stateChangeSuccess', function (ev, to, toParams, from, fromParams) {
      if (from.name) { $rootScope.navigated = true; }
  });
})

.config(function($stateProvider, $urlRouterProvider, $httpProvider) {
  $stateProvider
    .state('home', {
          url: '/',
          templateUrl: 'templates/main.html',
          controller: 'AppCtrl'
    })
    .state('journey', {
        url: '/journeys/:journeyId',
        templateUrl: "templates/posts.html",
        controller: 'PostsCtrl'
    })
    .state('post', {
        url: '/journeys/:journeyId/posts/:postId',
        templateUrl: "templates/comments.html",
        controller: 'CommentsCtrl'
    })


  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/');

  //Enable cross domain calls
  $httpProvider.defaults.useXDomain = true;

  //Remove the header containing XMLHttpRequest used to identify ajax call 
  //that would prevent CORS from working
  delete $httpProvider.defaults.headers.common['X-Requested-With'];

});
