
angular.module('appControllers', [])

.controller('AppCtrl', function($scope, $rootScope, $state, $stateParams, $ionicModal, $ionicScrollDelegate, $timeout, $interpolate, $ionicSideMenuDelegate, $interval, Journey, JourneyCheckin, Person, Keys) {
    initWeb = function() {
        getLocation = function() {
            $rootScope.currentLocation = getDefaultLocation();  // Should get from the browser
            FlurryAgent.setLocation($rootScope.currentLocation.lat, $rootScope.currentLocation.lon, 100);
        }
        $rootScope.getPerson();
        $rootScope.getKeys();
        getLocation();
    }
    initDevice = function() {
        getLocation = function() {
            /* Getting the current location via cordova */

            // geolocation option

            var options = {
            	"enableHighAccuracy": 	true,
            	"maximumAge": 			10000,
            	"timeout":				5000
            };

            navigator.geolocation.getCurrentPosition(function(position) {
            	//alert("Navigator - Your current position is " + position.coords.latitude + " : " + position.coords.longitude);
	        	$rootScope.currentLocation = {"lat": position.coords.latitude, "lon": position.coords.longitude};
	            FlurryAgent.setLocation($rootScope.currentLocation.lat, $rootScope.currentLocation.lon, 100);
            }, function(error) {
           		//alert("Navigator - We can't get the location with high accuracy. Error: " + error.message);

				if ((typeof native != "undefined") && (typeof native.geolocation != "undefined")) {
					// GPS Provider
					var options = {
						"type":					"gps",
						"enableHighAccuracy": 	true,
						"maximumAge": 			10000,
						"timeout":				20000
					};
	
					native.geolocation.getCurrentPosition(function(position) {
						//alert("GPS - Your current position is " + position.coords.latitude + " : " + position.coords.longitude);
						$rootScope.currentLocation = {"lat": position.coords.latitude, "lon": position.coords.longitude};
						FlurryAgent.setLocation($rootScope.currentLocation.lat, $rootScope.currentLocation.lon, 100);
					}, function(error) {
						//alert("GPS - We can't get the location. Error: " + error.message);
	
						// WIFI Provider
						var options = {
							"type":					"wifi",
							"enableHighAccuracy": 	true,
							"maximumAge": 			10000,
							"timeout":				5000
						};
	
						native.geolocation.getCurrentPosition(function(position) {
							//alert("WIFI - Your current position is " + position.coords.latitude + " : " + position.coords.longitude);
							$rootScope.currentLocation = {"lat": position.coords.latitude, "lon": position.coords.longitude};
							FlurryAgent.setLocation($rootScope.currentLocation.lat, $rootScope.currentLocation.lon, 100);
						}, function(error) {
							//alert("WIFI - We can't get the location. Error: " + error.message);
	
							// Google Location Service
							var options = {
								"type":					"gls",
								"enableHighAccuracy": 	true,
								"maximumAge": 			10000,
								"timeout":				20000
							};
	
							native.geolocation.getCurrentPosition(function(position) {
								//alert("Google Location Service - Your current position is " + position.coords.latitude + " : " + position.coords.longitude);
								$rootScope.currentLocation = {"lat": position.coords.latitude, "lon": position.coords.longitude};
								FlurryAgent.setLocation($rootScope.currentLocation.lat, $rootScope.currentLocation.lon, 100);
							}, function(error) {
								//alert("Google Location Service - We can't get the location. Error: " + error.message);
	
								/*
								// Cellular Provider
								var options = {
									"type":					"cellular",
									"enableHighAccuracy": 	true,
									"maximumAge": 			10000,
									"timeout":				20000
								};
	
								native.geolocation.getCurrentPosition(function(position) {
									alert("Cellular - Your current position is " + position.coords.latitude + " : " + position.coords.longitude);
									$rootScope.currentLocation = {"lat": position.coords.latitude, "lon": position.coords.longitude};
									FlurryAgent.setLocation($rootScope.currentLocation.lat, $rootScope.currentLocation.lon, 100);
								}, function(error) {
									alert("Cellular - We can't get the location. Error: " + error.message);
								}, options);
								*/
	
								alert("This app works better if it knows your location. Please enable location services.");
							}, options);
	
						}, options);
	
					}, options);
				}	
				else {
					alert("This app works better if it knows your location. Please enable location services.");
				}

           	}, options);

            $rootScope.currentLocation = getDefaultLocation();
        };
        checkConnection = function() {
            var networkState = navigator.connection.type;
            if (networkState !== Connection.NONE && networkState !== Connection.UNKNOWN) {
              $rootScope.getPerson();
              $rootScope.getKeys();
            }  // TODO: Need an error handler
        };
        onDeviceReady = function() {
            // Wait for PhoneGap to load
            checkConnection();
            getLocation();
        };
        document.addEventListener("deviceready", onDeviceReady, false);
    }
    initRootScope = function() {
        $rootScope.sections = [
            {id: 1, name: 'Love & Hate', slug: 'love-and-hate'},
            {id: 2, name: 'Missed Connections', slug: 'missed-connections'},
            {id: 3, name: 'Notes & Visitors', slug: 'notes-and-visitors'},
            {id: 4, name: 'Tips & Tricks', slug: 'tips-and-tricks'},
            {id: 5, name: 'Secrets & Stories', slug: 'secrets-and-stories'}
        ];
        $rootScope.modes = [
            {id: 1, name: 'Car', img: 'img/modes/car.png'},
            {id: 2, name: 'Bus', img: 'img/modes/bus.png'},
            {id: 3, name: 'Train', img: 'img/modes/train.png'},
            {id: 4, name: 'Foot', img: 'img/modes/pedestrian.png'},
            {id: 5, name: 'Wheelchair', img: 'img/modes/wheelchair.png'},
            {id: 6, name: 'Bicycle', img: 'img/modes/bicycle.png'},
            {id: 7, name: 'Scooter', img: 'img/modes/scooter.png'},
            {id: 8, name: 'Motorcycle', img: 'img/modes/motorcycle.png'},
            {id: 9, name: 'Taxi', img: 'img/modes/taxi.png'},
            {id: 10, name: 'Rideshare', img: 'img/modes/rideshare.png'},
            {id: 11, name: 'Trolley', img: 'img/modes/trolley.png'},
            {id: 12, name: 'Rollerblades', img: 'img/modes/rollerblades.png'},
            {id: 13, name: 'Horse', img: 'img/modes/horse.png'},
            {id: 14, name: 'Skateboard', img: 'img/modes/skateboard.png'},
            {id: 15, name: 'Kayak', img: 'img/modes/kayak.png'},
            {id: 16, name: 'Sailboat', img: 'img/modes/sailboat.png'},
            {id: 17, name: 'Boat', img: 'img/modes/boat.png'},
            {id: 18, name: 'Ship', img: 'img/modes/ship.png'},
            {id: 19, name: 'Helicopter', img: 'img/modes/helicopter.png'},
            {id: 20, name: 'Airplane', img: 'img/modes/airplane.png'},
            {id: 21, name: 'Rocket Ship', img: 'img/modes/rocketship.png'},
        ];
        $rootScope.systemMode = {name: 'UFO', img: 'img/modes/ufo.png'},
        $rootScope.sectionColors = ['pale-orange','rust','goldenrod','sage','blue'];

        $rootScope.currentLocation = getDefaultLocation();
        $rootScope.setModeModal = null;
        $rootScope.showCheckinMsg = false;

        FlurryAgent.startSession(flurryAPIKey);
		FlurryAgent.logEvent("SplashScreen");

        $rootScope.getPerson = function() {
          if ($rootScope.currentPerson === null || typeof $rootScope.currentPerson === 'undefined' || $rootScope.currentPerson === {}) {
            $scope.isPersonLoaded = false;
            // first try to get the personId from the localstorage
            $rootScope.personId = window.localStorage.getItem("nonplacesPersonId");
            $rootScope.personSecret = window.localStorage.getItem("nonplacesPersonSecret");
            if (typeof $rootScope.personId === 'undefined' || $rootScope.personId === null || $rootScope.personId === '') {
              // create a new person
              var person = new Person({});
              person.$save(
                {},
                function(res) {
	                if (res.success === true) {  // Should be using HTTP status here
	                  $rootScope.currentPerson = res.person;
	                  $rootScope.personId = res.person.id;
	                  $rootScope.personSecret = res.person.secret;
	                  window.localStorage.setItem("nonplacesPersonId", res.person.id);
	                  window.localStorage.setItem("nonplacesPersonSecret", res.person.secret);
	                  $rootScope.isNewPerson = true;
	                  $scope.isPersonLoaded = true;
	                } else {
	                  $rootScope.currentPerson = null;
	                  $rootScope.isNewPerson = false;
	                  $scope.isPersonLoaded = false;
	                }
              	},
              	function(error) {
              		onHttpError(error);
              	}
              );
            } else {
              // load the persons previous journeys
              $rootScope.journeys = Journey.query({
                personId : $rootScope.personId,
                secret: $rootScope.personSecret
              }, function(success) {
              }, function(error) {
              	onHttpError(error);
              });

              // got the personId from local storage
              $rootScope.currentPerson = Person.get(
                {
                  personId : $rootScope.personId,
                  secret: $rootScope.personSecret
                },
                function(p) {
                  // check http codes for success
                  $rootScope.isNewPerson = false;
                  $scope.isPersonLoaded = true;
                },
                function(error) {
                }
           	  );
            }
          }
        };
        $rootScope.getKeys = function() {
          if (typeof window.keys === 'undefined' || window.keys === null) {
            // store the keys globally, since we need this in the helpers.js
            // which is outside of the Angular application scope
            window.keys = Keys.get();
          }
        };
        $rootScope.isOnJourneyById = function(journeyId) {
          return (typeof $rootScope.currentJourneyCheckin !== 'undefined' &&
                  $rootScope.currentJourneyCheckin !== null &&
                  $rootScope.currentJourneyCheckin.journey.id === journeyId);
        };
        $rootScope.isNotOnJourneyById = function(journeyId) {
          return !($rootScope.isOnJourneyById(journeyId));
        };
        $rootScope.checkOnJourney = function() {
          if (typeof $rootScope.currentJourneyCheckin !== 'undefined' &&
              $rootScope.currentJourneyCheckin !== null) {
                  $rootScope.onJourney = true;

                  // End the current journey if it's stale ( > 12 hours old)
                  var departureTime = Date.parse($rootScope.currentJourneyCheckin.departureTime);
                  var currentTime = new Date();
                  var diffTime = currentTime - departureTime;
                  var twelveHours = 1000 * 60 * 60 * 12;
                  if (diffTime > twelveHours) {
                    $rootScope.onJourney = false;
                    $rootScope.currentJourneyCheckin = null;
                  }
          } else {
                  $rootScope.onJourney = false;
          }
        };
        $rootScope.onSelectedJourney = function() {
          return $rootScope.isOnJourneyById($rootScope.selectedJourney.id)
        }
        $rootScope.checkinModeFromEndpoints = function(modeId) {
          $scope.isLoading = true;
          checkin = new JourneyCheckin({
            fromPlace: prepPlaceDataForPost($scope.selectedFromLocation),
            toPlace: prepPlaceDataForPost($scope.selectedToLocation),
            modeId: modeId,
            personId: $rootScope.currentPerson.id,
            secret: $rootScope.personSecret
          });
          checkin.$save(
            {
              personId: $rootScope.currentPerson.id,
              secret: $rootScope.personSecret
            },
            function(res) {
              $scope.isLoading = false;
              if (res.success === true) {
                $rootScope.currentJourneyCheckin = res.journeyCheckin;
                $rootScope.selectedJourney = $rootScope.currentJourneyCheckin.journey;
                $rootScope.journeyInfo = Journey.get({
                  journeyId: $rootScope.selectedJourney.id,
                  personId: $rootScope.currentPerson.id,
                  secret: $rootScope.personSecret
                });
                $rootScope.currentModeId = modeId;
                $rootScope.showCheckinMsg = true;
                $scope.cleanup();
                $state.go('journey', {journeyId: $rootScope.selectedJourney.id});
              }
            }, function(error) {
            	$scope.isLoading = false;
          		onHttpError(error);
          	});
        };
        $rootScope.checkinModeFromJourney = function(modeId, journeyId) {
          $scope.isLoading = true;
          checkin = new JourneyCheckin({
            journeyId : journeyId,
            modeId: modeId,
            personId: $rootScope.currentPerson.id,
            secret: $rootScope.personSecret
          });
          checkin.$save(
            {
              personId: $rootScope.currentPerson.id,
              secret: $rootScope.personSecret
            },
            function(res) {
              $scope.isLoading = false;
              if (res.success === true) {
                $rootScope.currentJourneyCheckin = res.journeyCheckin;
                $rootScope.journeyInfo = Journey.get({
                  journeyId: journeyId,
                  personId: $rootScope.currentPerson.id,
                  secret: $rootScope.personSecret
                });
                $rootScope.currentModeId = modeId;
                $rootScope.showCheckinMsg = true;
                $scope.cleanup();
                $state.go('journey', {journeyId: $rootScope.selectedJourney.id});
              }
            }, function(error) {
            	$scope.isLoading = false;
          		onHttpError(error);
          	});
        };
        $rootScope.goToLink = function(uri) {
          if (typeof window.cordova === 'undefined') {
            window.open(uri, "_blank");  // open link in a new browser window
          } else {
            window.open(uri, "_system"); // open link in the system browser
          }
        };

    }
    init = function() {
        /**************************/
        /* Initial State          */
        /**************************/
        $scope.isSplashShowing = !$scope.navigated;;
        $scope.isWelcomeShowing = false;
        $scope.isNewMinimized = false;
        $scope.isLoading = false;
        $scope.locationLabel = {};
        $scope.locationLabel.from = "e.g. Space Needle";
        $scope.locationLabel.to = "e.g. Pike Place Market";
        $scope.showModeSelector = false;
        $scope.selectedFromLocation = null;
        $scope.selectedToLocation = null;

        /***********************************************************/
        /* Add new location modal for specifying from/to locations */
        /***********************************************************/

        $ionicModal.fromTemplateUrl('templates/from-modal.html', function($ionicModal) {
                $scope.fromModal = $ionicModal;
            }, {
                scope: $scope,
                animation: 'slide-in-up'
            });


        $ionicModal.fromTemplateUrl('templates/to-modal.html', function($ionicModal) {
                $scope.toModal = $ionicModal;
            }, {
                scope: $scope,
                animation: 'slide-in-up'
            });


        $scope.isFromTypeaheadInit = false;
        $scope.isToTypeaheadInit = false;

        $scope.showFromModal = function() { $scope.fromModal.show(); };
        $scope.hideFromModal = function() { $scope.fromModal.hide(); };
        $scope.showToModal = function() {
        	$scope.toModal.show();
        	/*
        	$scope.items = [
        		"on-touch",
        		"on-tap"
        	];
        	$scope.clicked = function(what, event) {
        		if (event) {
        			event.stopPropogation();
        			event.preventDefault();
        		}
        	}
        	*/
        };
        $scope.hideToModal = function() { $scope.toModal.hide(); };

        $scope.showNextModal = function() {
          if ($scope.selectedFromLocation === null) {
            $timeout(function() { $scope.showFromModal(); }, 400);
          } else if ($scope.selectedToLocation === null) {
            $timeout(function() { $scope.showToModal(); }, 400);
          } else  {
            $timeout(function() { $scope.showSetModeModal(true); }, 400);
          }
        };
        $scope.$on('modal.shown', function(a, b) {
        	FlurryAgent.logEvent("JourneyInput");
            var isFrom = $(b.el.firstChild.firstChild).data('is-from');
            if (isFrom === true) {
              if (!$scope.isFromTypeaheadInit) {
                // typeahead can only be initialized once the modal is attached to the dom
                initTypeahead(isFrom);
                $scope.isFromTypeaheadInit = true;
              }
            }
            if (isFrom === false) {
              // Do the same thing for the 'to' modal
              if (!$scope.isToTypeaheadInit) {
                initTypeahead(isFrom);
                $scope.isToTypeaheadInit = true;
              }
            }

            /*
             *  set an interval to check for resizes in the modal (e.g. when keyboard opens and closes)
             *  so that tt-dropdown-menu (the typeahead menu) can be resized accordingly.
             *  save a handle to the interval so we can stop it on modal:hide
             *  This is an a messy way to handle the modal height change, but I couldn't figure out an
             *  obvious way to do so with pure CSS because of the positionings of the modal / typeahead.
             */
            $scope.modalInterval = setInterval($scope.checkForModalHeightChange(isFrom), 250);
        });
        $scope.$on('modal.hidden', function(a, b) {
            // cleanup the timeOUt
            if ($scope.modalInterval) {
              clearInterval($scope.modalInterval);
              $scope.modalInterval = 0;
            }
        });
        $scope.checkForModalHeightChange = function(isFrom) {
            var fromToSelector = (isFrom ? '.new-journey-modal-from' : '.new-journey-modal-to' )
            return function() {
              var $newJourneyModal = $(fromToSelector);
              var $dropDownMenu =  $newJourneyModal.find('.tt-dropdown-menu');
              var newJourneyModalHeight = $newJourneyModal.height()
              $dropDownMenu.height(newJourneyModalHeight - 75);
            }
        };

        /******************/
        /* Set Mode Modal */
        /******************/

        $scope.showSetModeModal = function(isNewJourney) {
        	FlurryAgent.logEvent("JourneyInput");
            if ($scope.setModeModal === null) {
              $ionicModal.fromTemplateUrl('templates/set-mode-modal.html', {
                  scope: $scope,
                  animation: 'slide-in-up'
                }).then(function(modal) {
                  $scope.setModeModal = modal;
                  $scope.setModeModal.selectedModeId = null;
                  $scope.setModeModal.selectedMode = null;
                  $scope.setModeModal.isNewJourney = isNewJourney;
                  modal.show();
                });
            } else {
              $scope.setModeModal.selectedModeId = null;
              $scope.setModeModal.selectedMode = null;
              $scope.setModeModal.isNewJourney = isNewJourney;
              $scope.setModeModal.show();
            }
        };
        $scope.hideSetModeModal = function() {
            $scope.setModeModal.hide();
        };
        $scope.submitSetModeModal = function() {
        	FlurryAgent.logEvent("JourneyPage");
            $scope.hideSetModeModal();
            var modeId = $scope.setModeModal.selectedModeId;
            if ($scope.setModeModal.isNewJourney) {
              $scope.checkinModeFromEndpoints(modeId);
            } else {
              $scope.checkinModeFromJourney(modeId, $rootScope.selectedJourney.id);
            }
        };
        $scope.selectMode = function(modeId) {
          $scope.setModeModal.selectedModeId = modeId;
          $scope.setModeModal.selectedMode = $rootScope.modes[modeId-1];
        };

        /******************/
        /* Side Menu      */
        /******************/

        $scope.toggleLeftSideMenu = function() {
          FlurryAgent.logEvent("StatsSideBar");
          $ionicSideMenuDelegate.toggleLeft();
        };

        /*********************************/
        /* Splash Page and Welcome (first time user) Page */
        /*********************************/

        var el_clouds = document.getElementById('clouds');
        var pos = 0;
        var moveClouds = function(){
            el_clouds.style.left = (pos)+'px';
            pos -= 0.40;
            if (pos < -45) {
              if ($scope.isPersonLoaded) {
                $scope.isSplashShowing = false;
                if ($rootScope.isNewPerson)
                  $scope.isWelcomeShowing = true;
              } else {
                $timeout(moveClouds, 27);
              }
            } else {
                $timeout(moveClouds, 27);
            }
        }
        moveClouds();

        $scope.closeWelcome = function() { $scope.isWelcomeShowing = false; };

        /*
         * current journey interval:
         *     the current journey should expire after a fixed time.
         *     continuously poll to check for expiration
         */
        $interval($rootScope.checkOnJourney, 5000);

    };

    initTypeahead = function(isFrom) {
      var address = new Bloodhound({
        datumTokenizer: function(d) {
          return Bloodhound.tokenizers.whitespace(d.name);
        },
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        limit: 3,
        remote: {
          url: bingQueryURL($rootScope.currentLocation),
          filter: function (response) {
            if (typeof response.resourceSets === 'undefined' || typeof response.resourceSets[0] === 'undefined') {
              return []
            } else {
              var data = response.resourceSets[0].resources;
              return $.map( data, function( a ) { a.source = 'address'; return a; } );
            }
          },
          ajax: $.ajax({type:'GET',dataType:'jsonp'})
        }
      });

      var venue = new Bloodhound({
        datumTokenizer: function(d) {
          return Bloodhound.tokenizers.whitespace(d.name);
        },
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        limit: 3,
        remote: {
          url: foursquareQueryURL($rootScope.currentLocation),
          filter: function (dat) {
            var data = dat.response.venues;
            return $.map( data, function( a ) { a.source = 'venue'; return a; } );
          },
        }
      });

      address.initialize();
      venue.initialize();

      var typeaheadOptions = {
        highlight: false,
        hint: false,
        minLength: 2,
      };

      var placeData = [
        {
          name: 'venues',
          displayKey: 'name',
          source: venue.ttAdapter(),
          limit: 3,
          templates: {
            header: '<div class="tt-source-header"><span class="type">Venues</span><span class="attribution">powered by Foursquare</span></div>',
            suggestion: $interpolate([
              '<div class="tt-suggestion-name">{{name}}</div>',
              '<div class="tt-suggestion-address">{{location.formattedAddress.join(", ")}}</div>',
            ].join('\n'))
          }
        },
        {
          name: 'addresses',
          displayKey: 'name',
          source: address.ttAdapter(),
          limit: 3,
          templates: {
            header: '<div class="tt-source-header"><span class="type">Addresses</span><span class="attribution">powered by Bing</span></div>',
            suggestion: $interpolate([
              '<div class="tt-suggestion-name">{{name}}</div>',
            ].join('\n'))
          }
        }
      ];

      // select which typeahead we're initializing (the from typeahead or the to typeahead)
      var selectorClass = '.typeahead-to';
      if (isFrom) {
        selectorClass = '.typeahead-from';
      }
      $(selectorClass).typeahead(typeaheadOptions, placeData)
        .on('typeahead:selected', function (obj, datum, name) {
          /*
           * When a user taps an item from the typeahead menu, we want to pull the returned
           * address/venue data from bing/foursquare and set it onto our scope
           */
          if (isFrom) {
              $scope.locationLabel.from = datum.name;
              $scope.selectedFromLocation = datum;
              $scope.hideFromModal();
          } else {
              $scope.locationLabel.to = datum.name;
              $scope.selectedToLocation = datum;
              $scope.hideToModal();
          }
          $scope.showNextModal();

          /*
           * If selectedFromLocation and selectedToLocation are set,
           * we want to open the mode selection menu
           */
          if ($scope.selectedFromLocation !== null && $scope.selectedToLocation !== null &&
              typeof $scope.selectedFromLocation === 'object' && typeof $scope.selectedToLocation === 'object') {
              $scope.showModeSelector = true;
          } else {
              $scope.showModeSelector = false;
          }
        });
    };

    $scope.expandNewJourney = function(){
        /* THIS FEATURE IS CURRENTLY DISABLED. */
        /* IT IS MEANT TO COLLAPSE AND MINIMIZE THE NEW JOURNEY WINDOW ON SCROLL */
        /* BUT IS CURRENTLY TOO CHOPPY FOR RELEASE */

        // $ionicScrollDelegate.$getByHandle('list-journeys').scrollTop();
        // $scope.isNewMinimized = false;
    };
    $scope.scrollJourneys = function(){
        /* THIS FEATURE IS CURRENTLY DISABLED. */
        /* IT IS MEANT TO COLLAPSE AND MINIMIZE THE NEW JOURNEY WINDOW ON SCROLL */
        /* BUT IS CURRENTLY TOO CHOPPY FOR RELEASE */

        // safeApply($scope, function () {
        //     var offset = $ionicScrollDelegate.$getByHandle('list-journeys').getScrollPosition().top;
        //     $scope.isNewMinimized = (offset > 0);
        // });
    };
    $scope.tapJourney = function(index){
        $rootScope.selectedJourney = $rootScope.journeys[index];
        $scope.showSetModeModal(false);
    }
    $scope.tapCurrentJourney = function() {
        $rootScope.selectedJourney = $rootScope.currentJourneyCheckin.journey;
        $scope.cleanup()
        $state.go('journey', {journeyId: $rootScope.selectedJourney.id});
    }
    $scope.cleanup = function() {
        if (typeof $scope.fromModal !== 'undefined' && $scope.fromModal !== null) {
          $scope.fromModal.remove();
        }
        if (typeof $scope.toModal !== 'undefined' && $scope.toModal !== null) {
          $scope.toModal.remove();
        }
        if (typeof $scope.setModeModal !== 'undefined' && $scope.setModeModal !== null) {
          $scope.setModeModal.remove();
        }
    }

    initRootScope();   // Initialize the global state (scoped for the entire app)
    if (typeof window.cordova === 'undefined') {
      initWeb();       // we are running in the browswer, init browser specific options
    } else {
      initDevice();    // we are running on a device, init device specific options
    }
    init();            // Initialize the state for the main page
})

.controller('PostsCtrl', function($scope, $rootScope, $state, $stateParams, $ionicModal, $window, $timeout, $ionicActionSheet, Journey, Person, Post, ContentFlag) {
    init = function() {
        $scope.isPostsLoaded = false;
        $scope.isJourneyInfoLoaded = false;
        $scope.loadPosts();
        $scope.loadJourneyInfo();
        if ($rootScope.showCheckinMsg) {
          $scope.showCheckinMsgModal();
        }
    }
    $scope.loadPosts = function() {
        $scope.posts = Post.get(
          {
            journeyId: $stateParams.journeyId,
            personId: $rootScope.currentPerson.id,
            secret: $rootScope.personSecret
          },
          function() {
            $scope.isPostsLoaded = true;
          });
    }
    $scope.loadJourneyInfo = function() {
        $rootScope.journeyInfo = Journey.get(
          {
            journeyId: $stateParams.journeyId,
            personId: $rootScope.currentPerson.id,
            secret: $rootScope.personSecret
          },
          function() {
              $scope.isJourneyInfoLoaded = true;
          });
    }
    $scope.goComments = function(index) {
        $rootScope.selectedPost = $scope.posts[index];
        $scope.cleanup();
        $state.go('post', {journeyId: $stateParams.journeyId, postId: $rootScope.selectedPost.id});
    }
    $scope.goBack = function () {
        // $scope.removeCheckinModal();
        $scope.hideContentModal();

        // reload the journeys and person info
        $rootScope.journeys = Journey.query({
          personId : $rootScope.currentPerson.id,
          secret: $rootScope.personSecret
        }, function(success) {
        }, function(error) {
          onHttpError(error);
        });

        $rootScope.currentPerson = Person.get(
          {
            personId : $rootScope.currentPerson.id,
            secret: $rootScope.personSecret
          },
          function(p) {
            // check http codes for success
            $rootScope.isNewPerson = false;
            $scope.isPersonLoaded = true;
          });

        $scope.cleanup();
        $window.history.back();

    }
    $scope.submitContentModal = function() {
      var post = new Post({
        sectionId: $scope.contentModal.sectionId,
        personId: $rootScope.currentPerson.id,
        text: $scope.contentModal.text,
        journeyCheckinId: $rootScope.currentJourneyCheckin.id,
        journeyId: $rootScope.currentJourneyCheckin.journey.id,
        modeId: $rootScope.currentModeId,
        isAnon: !$scope.contentModal.useIdentity
      });
      post.$save(
        {
          sectionId: $scope.contentModal.sectionId,
          journeyId: $rootScope.currentJourneyCheckin.journey.id,
          personId: $rootScope.currentPerson.id,
          secret: $rootScope.personSecret
        },
        function(data) {
            $scope.loadPosts();
            $scope.loadJourneyInfo();
        },
        function(error) {
        	onHttpError(error);
        }
      );
      $scope.hideContentModal();
    }
    $scope.nextPostSection = function() {
      $scope.contentModal.sectionId = ($scope.contentModal.sectionId % 5) + 1;
      $scope.contentModal.section = $rootScope.sections[$scope.contentModal.sectionId-1];
      $scope.contentModal.sectionColor = $rootScope.sectionColors[$scope.contentModal.sectionId-1];
    }
    $scope.showContentModal = function() {
    	FlurryAgent.logEvent("NoteInput");
        var initContentModal = function() {
          $scope.contentModal.text = "";
          $scope.contentModal.useIdentity = true;
          $scope.contentModal.sectionId = 3;
          $scope.contentModal.section = $rootScope.sections[$scope.contentModal.sectionId-1];
          $scope.contentModal.sectionColor = $rootScope.sectionColors[$scope.contentModal.sectionId-1];
        }

        if (typeof $scope.contentModal === 'undefined' || $scope.contentModal === null) {
          $ionicModal.fromTemplateUrl('templates/new-post-modal.html', {
              scope: $scope,
              animation: 'slide-in-up'
            }).then(function(modal) {
              $scope.contentType = 'post';
              $scope.contentModal = modal;
              initContentModal();
              $scope.contentModal.show();
            });
        } else {
          initContentModal();
          $scope.contentModal.show();
        }

    };
    $scope.hideContentModal = function() {
        if (typeof $scope.contentModal !== 'undefined' && $scope.contentModal !== null) {
          $scope.contentModal.hide();
        }
    }
    $scope.removeContentModal = function() {
        if (typeof $scope.contentModal !== 'undefined' && $scope.contentModal !== null) {
          $scope.contentModal.remove().then(function() {$scope.contentModal.text = "";});
        }
    };
    $scope.showCheckinMsgModal = function() {
        if (typeof $scope.checkinMsgModal === 'undefined' || $scope.checkinMsgModal === null || !$scope.checkinMsgModal.isShown()) {
          $ionicModal.fromTemplateUrl('templates/checkin-msg-modal.html', {
              scope: $scope,
              animation: 'slide-in-up'
            }).then(function(modal) {
              $scope.checkinMsgModal = modal;
              $timeout(function() { $scope.checkinMsgModal.show(); }, 800);
            });
        }
    };
    $scope.hideCheckinMsgModal = function() { $scope.removeCheckinMsgModal(); }
    $scope.removeCheckinMsgModal = function() {
        if (typeof $scope.checkinMsgModal !== 'undefined' && $scope.checkinMsgModal !== null) {
          $scope.checkinMsgModal.remove();
        }
        $rootScope.showCheckinMsg = false;
    };

    /*
     * Showing actions on a piece of content (post or comment)
     */
    $scope.showActions = function(post) {

      var options  = {
        buttons: [
          { text: 'Flag as Inappropriate' }
        ],
        titleText: 'Options',
        cancelText: 'Cancel',
        cancel: function() {
          hideSheet();
        },
        buttonClicked: function(index) {
          if (index === 0) {
            hideSheet();

            // flag as inappropriate
            $scope.showConfirmActionModal("do you want to flag this note as inappropriate?", $scope.flagContent, post, true);
          }
        }
      }

      if (post.author.id === $rootScope.currentPerson.id) {
        options['destructiveText'] = 'Delete my Note';
        options['destructiveButtonClicked'] = function() {
            hideSheet();

            // delete this content
            $scope.showConfirmActionModal("do you want to delete your note?", $scope.deleteContent, post, false);
        }
      }

      // Show the action sheet
      var hideSheet = $ionicActionSheet.show(options);

    };

    /*
     * Methods for showing a modal for confirming an action on a piece of content
     */

    $scope.showConfirmActionModal = function(actionText, actionMethod, actionParams, showLegal) {
        if (typeof $scope.contentModal == 'undefined' || $scope.contentModal === null || !$scope.contentModal.isShown()) {
          $ionicModal.fromTemplateUrl('templates/confirm-content-action-modal.html', {
              scope: $scope,
              animation: 'slide-in-up'
            }).then(function(modal) {
              $scope.confirmActionModal = modal;
              $scope.confirmActionModal.text = actionText;
              $scope.confirmActionModal.method = actionMethod;
              $scope.confirmActionModal.params = actionParams;
              $scope.confirmActionModal.showLegal = showLegal;
              $scope.confirmActionModal.show();
            });
        }
    };
    $scope.hideConfirmActionModal = function() {
        if (typeof $scope.confirmActionModal !== 'undefined' && $scope.confirmActionModal !== null) {
          $scope.confirmActionModal.remove();
        }
    };
    $scope.flagContent = function(post) {
        var cf = new ContentFlag({
          personId: $rootScope.currentPerson.id,
          contentId: post.id,
          contentType: "post",
          flagType: "inappropriate",
          secret: $rootScope.personSecret
        });
        cf.$save(
          {},
          function(res) {
	          if (res.success === true) {  // Should be using HTTP status here
	            $scope.confirmActionModal.text = "thank you! this content will be reviewed.";
	            $scope.hideConfirmActionModal();
	          } else {
	            $scope.confirmActionModal.text = "oop, something went wrong!";
	            $scope.hideConfirmActionModal();
	          }
          },
          function(error) {
          	  onHttpError(error);
          }
        );
    };
    $scope.deleteContent = function(post) {
        post.$remove(
          {
            journeyId: $rootScope.selectedJourney.id,
            postId: post.id,
            personId: $rootScope.currentPerson.id,
            secret: $rootScope.personSecret
          },
          function(res) {
            if (res.success === true) {  // Should be using HTTP status here
              $scope.loadPosts();
              $scope.confirmActionModal.text = "thank you!";
              $scope.hideConfirmActionModal();
            } else {
              $scope.confirmActionModal.text = "oop, something went wrong!";
              $scope.hideConfirmActionModal();
            }
          });
    };

    /*
     * Some cleanup functions
     */

    $scope.cleanup = function() {
        $scope.cleanupModals();
    };
    $scope.cleanupModals = function() {
        $scope.hideCheckinMsgModal();
        $scope.removeContentModal();
    };

    init();
})

.controller('CommentsCtrl', function($scope, $rootScope, $stateParams, $ionicModal, $ionicActionSheet, Comment, ContentFlag) {
    init = function() {
        $scope.isCommentsLoaded = false;
        $scope.loadComments();
        $scope.useIdentity = true;
    }
    $scope.loadComments = function() {
      $scope.comments = Comment.query(
        {
          postId: $stateParams.postId,
          personId: $rootScope.currentPerson.id,
          sectionId: $stateParams.sectionId,
          journeyId: $stateParams.journeyId,
          secret: $rootScope.personSecret
        },
        function(c) {
          $scope.isCommentsLoaded = true;
          if (c.length === 0 && $rootScope.onSelectedJourney()) {
            $scope.showContentModal();
          }
        }
      );
    }
    $scope.goBack = function () {
        $scope.cleanup();
        history.back();
    }
    $scope.submitContentModal = function() {
      var comment = new Comment({
        postId: $stateParams.postId,
        personId: $rootScope.currentPerson.id,
        text: $scope.contentModal.text,
        journeyCheckinId: $rootScope.currentJourneyCheckin.id,
        journeyId: $rootScope.currentJourneyCheckin.journey.id,
        modeId: $rootScope.currentModeId,
        isAnon: !$scope.contentModal.useIdentity,
        secret: $rootScope.personSecret
      });
      comment.$save(
      	{
      		journeyId: $rootScope.currentJourneyCheckin.journey.id,
      		postId: $stateParams.postId,
      		personId: $rootScope.currentPerson.id
      	},
      	function(data) {
        	$scope.loadComments();
      	},
      	function(error) {
      		onHttpError(error);
      	}
      );
      $scope.hideContentModal();
    }
    $scope.showContentModal = function() {
    	FlurryAgent.logEvent("ReplyInput");
        var initContentModal = function() {
          $scope.contentModal.text = "";
          $scope.contentModal.useIdentity = true;
          $scope.contentModal.sectionId = $rootScope.selectedPost.sectionId;
          $scope.contentModal.section = $rootScope.sections[$scope.contentModal.sectionId-1];
          $scope.contentModal.sectionColor = $rootScope.sectionColors[$scope.contentModal.sectionId-1];
        }

        if (typeof $scope.contentModal === 'undefined' || $scope.contentModal === null) {
          $ionicModal.fromTemplateUrl('templates/new-post-modal.html', {
              scope: $scope,
              animation: 'slide-in-up'
            }).then(function(modal) {
              $scope.contentType = 'comment';
              $scope.contentModal = modal;
              initContentModal();
              $scope.contentModal.show();
            });
        } else {
          initContentModal();
          $scope.contentModal.show();
        }

    };
    $scope.hideContentModal = function() {
        if (typeof $scope.contentModal !== 'undefined' && $scope.contentModal !== null) {
          $scope.contentModal.hide();
        }
    }
    $scope.removeContentModal = function() {
        if (typeof $scope.contentModal !== 'undefined' && $scope.contentModal !== null) {
          $scope.contentModal.remove().then(function() {$scope.contentModal.text = "";});
        }
    };

    /*
     * Showing actions on a piece of content (post or comment)
     */
    $scope.showActions = function(comment) {

      var options  = {
        buttons: [
          { text: 'Flag as Inappropriate' }
        ],
        titleText: 'Options',
        cancelText: 'Cancel',
        cancel: function() {
          hideSheet();
        },
        buttonClicked: function(index) {
          if (index === 0) {
            hideSheet();

            // flag as inappropriate
            $scope.showConfirmActionModal("do you want to flag this reply as inappropriate?", $scope.flagContent, comment, true);
          }
        }
      }

      if (comment.author.id === $rootScope.currentPerson.id) {
        options['destructiveText'] = 'Delete my Reply';
        options['destructiveButtonClicked'] = function() {
            hideSheet();

            // delete this content
            $scope.showConfirmActionModal("do you want to delete your reply?", $scope.deleteContent, comment, false);
        }
      }

      // Show the action sheet
      var hideSheet = $ionicActionSheet.show(options);

    };

    /*
     * Methods for showing a modal for confirming an action on a piece of content
     */

    $scope.showConfirmActionModal = function(actionText, actionMethod, actionParams, showLegal) {
        if (typeof $scope.contentModal == 'undefined' || $scope.contentModal === null || !$scope.contentModal.isShown()) {
          $ionicModal.fromTemplateUrl('templates/confirm-content-action-modal.html', {
              scope: $scope,
              animation: 'slide-in-up'
            }).then(function(modal) {
              $scope.confirmActionModal = modal;
              $scope.confirmActionModal.text = actionText;
              $scope.confirmActionModal.method = actionMethod;
              $scope.confirmActionModal.params = actionParams;
              $scope.confirmActionModal.showLegal = showLegal;
              $scope.confirmActionModal.show();
            });
        }
    };
    $scope.hideConfirmActionModal = function() {
        if (typeof $scope.confirmActionModal !== 'undefined' && $scope.confirmActionModal !== null) {
          $scope.confirmActionModal.remove();
        }
    };
    $scope.flagContent = function(comment) {
        var cf = new ContentFlag({
          personId: $rootScope.currentPerson.id,
          contentId: comment.id,
          contentType: "comment",
          flagType: "inappropriate",
          secret: $rootScope.personSecret
        });
        cf.$save(
          {},
          function(res) {
	          if (res.success === true) {  // Should be using HTTP status here
	            $scope.confirmActionModal.text = "thank you! this content will be reviewed.";
	            $scope.hideConfirmActionModal();
	          } else {
	            $scope.confirmActionModal.text = "oop, something went wrong!";
	            $scope.hideConfirmActionModal();
	          }
          },
          function(error) {
          	  onHttpError(error);
          }
        );
    };
    $scope.deleteContent = function(comment) {
        comment.$remove(
          {
            commentId: comment.id,
            postId: $stateParams.postId,
            personId: $rootScope.currentPerson.id,
            secret: $rootScope.personSecret
          },
          function(res) {
            if (res.success === true) {  // Should be using HTTP status here
              $scope.loadComments();
              $scope.confirmActionModal.text = "thank you!";
              $scope.hideConfirmActionModal();
            } else {
              $scope.confirmActionModal.text = "oop, something went wrong!";
              $scope.hideConfirmActionModal();
            }
          },
          function(error) {
          	onHttpError(error);
          }
        );
    };

    /*
     * Cleanup when we leave this scope
     */

    $scope.cleanup = function() {
        $scope.removeContentModal();
    };

    init();
});
